import java.util.*;
import java.util.Deque;
import java.util.Queue;

public class Lemming {

    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        int peatuste_arv = scanner.nextInt();
        int kohtade_arv = scanner.nextInt();
        int jk_pikkus = scanner.nextInt();
        Deque<Integer> tramm = new ArrayDeque<Integer>(); //pinu trammis olevate reisijate hoidmiseks
        Queue<Integer>[] trammisabad = new Queue[100]; //Massiiv trammisabadest peatustes

        for(int i = 0; i < 100; i++) {
            trammisabad[i] = new ArrayDeque<Integer>();
        }
        for (int i = 0; i < peatuste_arv; i++) { // iga peatuse kohta
            int ootajate_arv = scanner.nextInt(); // loeme ootajate arvu peatuses
            for (int j = 0; j < ootajate_arv; j++) { // ja iga ootaja kohta
                int sihtkoht = scanner.nextInt(); // loeme tema sihtkoha
                // ning paneme selles peatuses sabasse ootele
                trammisabad[i].add(sihtkoht - 1);
            }
        }

        int peatus = 0, kulunud_aeg = 0; // alustame esimesest peatusest
        while (true) {
            // mahalaadimine
            while (!tramm.isEmpty() && // kuni trammis on reisijaid ja
                    ((trammisabad[peatus].size() < jk_pikkus) || // peatuses on ruumi vi
                    tramm.peek() == peatus)) { // on jrgmine vljuja judnud sihtkohta
                if (tramm.peek() != peatus) { // kui jrgmine vljuja ei ole sihtkohas
                    // lheb ta selle peatuse sabasse
                    trammisabad[peatus].add(tramm.peek());            }
                tramm.pop(); // eemaldame vljuja trammist
                kulunud_aeg++; // lisame vljumiseks kulunud aja
            }

            boolean valmis = tramm.isEmpty(); // kas tramm on thi?
            for (int i = 0; i < peatuste_arv; i++) {
                valmis &= trammisabad[i].isEmpty(); // ja kik peatuste sabad on thjad?
            }
            if (valmis)
                break; // siis kik reisijad on kohal, lpetame

            kulunud_aeg += 5; // liidame peatuses sitmiseks kulunud aja

            // pealelaadimine
            while ((tramm.size() < kohtade_arv) && // kuni trammis on ruumi
                    !trammisabad[peatus].isEmpty()) { // ja peatuses on ootajaid
                // paneme trammi peatusest esimese ootaja
                tramm.push(trammisabad[peatus].peek());
                trammisabad[peatus].remove(); // ja eemaldame ta trammisabast
                kulunud_aeg++; // lisame sisenemiseks kulunud aja
            }

            peatus = (peatus + 1) % peatuste_arv; // jrgmine peatus
            kulunud_aeg += 60; // liidame peatuste vahel sitmiseks kulunud aja
        }

        System.out.println(kulunud_aeg); //vljastame kulunud aja
    }
}
